--- old/usr/src/uts/common/io/aac/aac.c	Thu Nov  1 14:48:24 2012
+++ new/usr/src/uts/common/io/aac/aac.c	Thu Nov  1 14:48:24 2012
@@ -1129,27 +1191,28 @@
 static uint_t
 aac_softintr(caddr_t arg)
 {
-	struct aac_softstate *softs = (void *)arg;
+	struct aac_softstate *softs = (struct aac_softstate *)arg;
 
 	if (!AAC_IS_Q_EMPTY(&softs->q_comp)) {
 		aac_drain_comp_q(softs);
+		return (DDI_INTR_CLAIMED);
+	} else {
+		return (DDI_INTR_UNCLAIMED);
 	}
-	return (DDI_INTR_CLAIMED);
 }
 
 /*
  * Setup auto sense data for pkt
  */
-static void
-aac_set_arq_data(struct scsi_pkt *pkt, uchar_t key,
-    uchar_t add_code, uchar_t qual_code, uint64_t info)
+static struct scsi_arq_status *
+aac_set_arq_common(struct scsi_pkt *pkt)
 {
-	struct scsi_arq_status *arqstat = (void *)(pkt->pkt_scbp);
+	struct scsi_arq_status *arqstat;
 
-	*pkt->pkt_scbp = STATUS_CHECK; /* CHECK CONDITION */
-	pkt->pkt_state |= STATE_ARQ_DONE;
+	pkt->pkt_state |= STATE_GOT_STATUS | STATE_ARQ_DONE;
 
-	*(uint8_t *)&arqstat->sts_rqpkt_status = STATUS_GOOD;
+	arqstat = (struct scsi_arq_status *)(pkt->pkt_scbp);
+	arqstat->sts_status.sts_chk = 1; /* CHECK CONDITION */
 	arqstat->sts_rqpkt_reason = CMD_CMPLT;
 	arqstat->sts_rqpkt_resid = 0;
 	arqstat->sts_rqpkt_state =
@@ -1159,6 +1222,32 @@
 	    STATE_XFERRED_DATA;
 	arqstat->sts_rqpkt_statistics = 0;
 
+	return (arqstat);
+}
+
+static void
+aac_copy_arq_data(struct scsi_pkt *pkt, uint8_t *sense_data, int32_t sense_len,
+    ddi_acc_handle_t acc)
+{
+	struct scsi_arq_status *arqstat;
+
+	arqstat = aac_set_arq_common(pkt);
+
+	if (sense_len > sizeof (struct scsi_extended_sense))
+		sense_len = sizeof (struct scsi_extended_sense);
+
+	ddi_rep_get8(acc, (uint8_t *)&arqstat->sts_sensedata,
+	    (uint8_t *)sense_data, sense_len, DDI_DEV_AUTOINCR);
+}
+
+static void
+aac_set_arq_data(struct scsi_pkt *pkt, uchar_t key,
+    uchar_t add_code, uchar_t qual_code, uint64_t info)
+{
+	struct scsi_arq_status *arqstat;
+
+	arqstat = aac_set_arq_common(pkt);
+
 	if (info <= 0xfffffffful) {
 		arqstat->sts_sensedata.es_valid = 1;
 		arqstat->sts_sensedata.es_class = CLASS_EXTENDED_SENSE;
@@ -1207,35 +1296,26 @@
 	union scsi_cdb *cdbp;
 	uint64_t err_blkno;
 
-	cdbp = (void *)acp->pkt->pkt_cdbp;
+	cdbp = (union scsi_cdb *)acp->pkt->pkt_cdbp;
 	err_blkno = AAC_GETGXADDR(acp->cmdlen, cdbp);
 	aac_set_arq_data(acp->pkt, KEY_HARDWARE_ERROR, 0x00, 0x00, err_blkno);
 }
 
 /*
- * Send a command to the adapter in New Comm. interface
+ * Setup auto sense data for UNIT ATTENTION
  */
-static int
-aac_send_command(struct aac_softstate *softs, struct aac_slot *slotp)
+/*ARGSUSED*/
+static void
+aac_set_arq_data_reset(struct aac_softstate *softs, struct aac_cmd *acp)
 {
-	uint32_t index, device;
+	struct aac_container *dvp = (struct aac_container *)acp->dvp;
 
-	index = PCI_MEM_GET32(softs, AAC_IQUE);
-	if (index == 0xffffffffUL) {
-		index = PCI_MEM_GET32(softs, AAC_IQUE);
-		if (index == 0xffffffffUL)
-			return (AACERR);
-	}
+	ASSERT(dvp->dev.type == AAC_DEV_LD);
 
-	device = index;
-	PCI_MEM_PUT32(softs, device,
-	    (uint32_t)(slotp->fib_phyaddr & 0xfffffffful));
-	device += 4;
-	PCI_MEM_PUT32(softs, device, (uint32_t)(slotp->fib_phyaddr >> 32));
-	device += 4;
-	PCI_MEM_PUT32(softs, device, slotp->acp->fib_size);
-	PCI_MEM_PUT32(softs, AAC_IQUE, index);
-	return (AACOK);
+	if (dvp->reset) {
+		dvp->reset = 0;
+		aac_set_arq_data(acp->pkt, KEY_UNIT_ATTENTION, 0x29, 0x02, 0);
+	}
 }
 
 static void
@@ -1245,10 +1325,8 @@
 	int q = AAC_CMDQ(acp);
 
 	if (acp->slotp) { /* outstanding cmd */
-		if (!(acp->flags & AAC_CMD_IN_SYNC_SLOT)) {
-			aac_release_slot(softs, acp->slotp);
-			acp->slotp = NULL;
-		}
+		aac_release_slot(softs, acp->slotp);
+		acp->slotp = NULL;
 		if (dvp) {
 			dvp->ncmds[q]--;
 			if (dvp->throttle[q] == AAC_THROTTLE_DRAIN &&
@@ -1255,61 +1333,41 @@
 			    dvp->ncmds[q] == 0 && q == AAC_CMDQ_ASYNC)
 				aac_set_throttle(softs, dvp, q,
 				    softs->total_slots);
-			/*
-			 * Setup auto sense data for UNIT ATTENTION
-			 * Each lun should generate a unit attention
-			 * condition when reset.
-			 * Phys. drives are treated as logical ones
-			 * during error recovery.
-			 */
-			if (dvp->type == AAC_DEV_LD) {
-				struct aac_container *ctp =
-				    (struct aac_container *)dvp;
-				if (ctp->reset == 0)
-					goto noreset;
-
-				AACDB_PRINT(softs, CE_NOTE,
-				    "Unit attention: reset");
-				ctp->reset = 0;
-				aac_set_arq_data(acp->pkt, KEY_UNIT_ATTENTION,
-				    0x29, 0x02, 0);
-			}
 		}
-noreset:
 		softs->bus_ncmds[q]--;
-		aac_cmd_delete(&softs->q_busy, acp);
+		(void) aac_cmd_delete(&softs->q_busy, acp);
 	} else { /* cmd in waiting queue */
 		aac_cmd_delete(&softs->q_wait[q], acp);
 	}
 
-	if (!(acp->flags & (AAC_CMD_NO_CB | AAC_CMD_NO_INTR))) { /* async IO */
-		mutex_enter(&softs->q_comp_mutex);
-		aac_cmd_enqueue(&softs->q_comp, acp);
-		mutex_exit(&softs->q_comp_mutex);
-	} else if (acp->flags & AAC_CMD_NO_CB) { /* sync IO */
-		cv_broadcast(&softs->event);
+	acp->cur_segment++;
+	if (acp->cur_segment >= acp->segment_cnt) {
+		if (!(acp->flags & (AAC_CMD_NO_CB | AAC_CMD_NO_INTR | AAC_CMD_AIF))) { /* async IO */
+			mutex_enter(&softs->q_comp_mutex);
+			aac_cmd_enqueue(&softs->q_comp, acp);
+			mutex_exit(&softs->q_comp_mutex);
+		} else if (acp->flags & AAC_CMD_NO_CB) { /* sync IO */
+			cv_broadcast(&softs->event);
+		}
+	} else {
+		acp->flags &= AAC_CMD_CONSISTENT | AAC_CMD_DMA_PARTIAL | \
+			AAC_CMD_BUF_READ | AAC_CMD_BUF_WRITE | AAC_CMD_DMA_VALID;
+		acp->timeout = acp->pkt->pkt_time;
+		if (acp->pkt->pkt_flags & FLAG_NOINTR)
+			acp->flags |= AAC_CMD_NO_INTR;
+		aac_do_io(softs, acp);
 	}
 }
 
 static void
-aac_handle_io(struct aac_softstate *softs, int index)
+aac_handle_io(struct aac_softstate *softs, struct aac_slot *slotp, int fast)
 {
-	struct aac_slot *slotp;
 	struct aac_cmd *acp;
-	uint32_t fast;
 
-	fast = index & AAC_SENDERADDR_MASK_FAST_RESPONSE;
-	index >>= 2;
-
 	/* Make sure firmware reported index is valid */
-	ASSERT(index >= 0 && index < softs->total_slots);
-	slotp = &softs->io_slot[index];
-	ASSERT(slotp->index == index);
 	acp = slotp->acp;
-
 	if (acp == NULL || acp->slotp != slotp) {
-		cmn_err(CE_WARN,
-		    "Firmware error: invalid slot index received from FW");
+		AACDB_PRINT(softs, CE_NOTE, "Command already freed, discarding");
 		return;
 	}
 
@@ -1335,23 +1393,105 @@
 			    &slotp->fibp->Header.XferState,
 			    state | AAC_FIBSTATE_DONEADAP);
 			ddi_put32(slotp->fib_acc_handle,
-			    (void *)&slotp->fibp->data[0], ST_OK);
+			    (uint32_t *)&slotp->fibp->data[0], ST_OK);
+			acp->flags |= AAC_CMD_FASTRESP;
 		}
 
 		/* Handle completed ac */
-		acp->ac_comp(softs, acp);
+		if (acp->cur_segment + 1 >= acp->segment_cnt)
+			acp->ac_comp(softs, acp);
 	} else {
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_UNAFFECTED);
+		aac_fm_service_impact(softs->devinfo_p, DDI_SERVICE_UNAFFECTED);
 		acp->flags |= AAC_CMD_ERR;
 		if (acp->pkt) {
 			acp->pkt->pkt_reason = CMD_TRAN_ERR;
 			acp->pkt->pkt_statistics = 0;
 		}
+		acp->cur_segment = acp->segment_cnt - 1;
 	}
 	aac_end_io(softs, acp);
 }
 
 /*
+ * Interrupt handler for New Comm. Type1 interface
+ */
+static int
+aac_process_intr_new_type1(struct aac_softstate *softs)
+{
+	struct aac_cmd *acp;
+	uint32_t bellbits, bellbits_shifted, index, handle;
+	int isFastResponse;
+	int our_interrupt = 0;
+
+	bellbits = PCI_MEM_GET32(softs, 0, AAC_SRC_ODBR_R);
+	if (bellbits & AAC_DB_RESPONSE_SENT_NS) {
+		bellbits = AAC_DB_RESPONSE_SENT_NS;
+		/* handle async. status */
+		our_interrupt = 1;
+		index = softs->aac_host_rrq_idx;
+		for (;;) {
+			isFastResponse = 0;
+			/* remove toggle bit (31) */
+			handle = (softs->comm_space->aac_host_rrq[index] & 0x7fffffff);
+			/* check fast response bit (30) */
+			if (handle & 0x40000000) 
+				isFastResponse = 1;
+
+			handle &= 0x0000ffff;
+			if (handle == 0) 
+				break;
+
+			acp = softs->io_slot[handle-1].acp;
+			ASSERT((handle-1) >= 0 && (handle-1) < softs->total_slots);
+			aac_handle_io(softs, &softs->io_slot[handle-1], isFastResponse);
+
+			softs->comm_space->aac_host_rrq[index++] = 0;
+			if (index == softs->aac_max_fibs) 
+				index = 0;
+			softs->aac_host_rrq_idx = index;
+
+			if (acp && (acp->flags & AAC_CMD_AIF)) {
+				if (acp->flags & AAC_CMD_AIF_NOMORE) {
+					kmem_free(acp, sizeof(struct aac_cmd));
+				} else {
+					acp->timeout = AAC_AIF_TIMEOUT;
+					acp->aac_cmd_fib = aac_cmd_aif_request;
+					acp->ac_comp = aac_aifreq_complete;
+					aac_do_io(softs, acp);
+				}
+			}
+		}
+	} else {
+		bellbits_shifted = (bellbits >> AAC_SRC_ODR_SHIFT);
+		if (bellbits_shifted & AAC_DB_AIF_PENDING) {
+			our_interrupt = 1;
+			/* handle AIF */
+			if ((acp = kmem_zalloc(sizeof(struct aac_cmd), KM_NOSLEEP)) != NULL) {
+				acp->timeout = AAC_AIF_TIMEOUT;
+				acp->aac_cmd_fib = aac_cmd_aif_request;
+				acp->ac_comp = aac_aifreq_complete;
+				aac_do_io(softs, acp);
+			}
+		} else if (bellbits_shifted & AAC_DB_SYNC_COMMAND) {
+			if (softs->sync_mode_slot) {
+				our_interrupt = 1;
+				aac_handle_io(softs, softs->sync_mode_slot, isFastResponse);
+				softs->sync_slot_busy = 0;
+			}
+		}
+	}
+	if (our_interrupt) 
+		PCI_MEM_PUT32(softs, 0, AAC_SRC_ODBR_C, bellbits);
+
+    /*
+     * Process waiting cmds before start new ones to
+     * ensure first IOs are serviced first.
+     */
+    aac_start_waiting_io(softs);
+    return (our_interrupt ? AAC_DB_COMMAND_READY:0);
+}
+
+/*
  * Interrupt handler for New Comm. interface
  * New Comm. interface use a different mechanism for interrupt. No explict
  * message queues, and driver need only accesses the mapped PCI mem space to
@@ -1361,21 +1501,25 @@
 aac_process_intr_new(struct aac_softstate *softs)
 {
 	uint32_t index;
+    int fast;
 
 	index = AAC_OUTB_GET(softs);
 	if (index == 0xfffffffful)
 		index = AAC_OUTB_GET(softs);
-	if (aac_check_acc_handle(softs->pci_mem_handle) != DDI_SUCCESS) {
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_UNAFFECTED);
-		return (0);
+	if (aac_check_acc_handle(softs->pci_mem_handle[0]) != DDI_SUCCESS) {
+		aac_fm_service_impact(softs->devinfo_p, DDI_SERVICE_UNAFFECTED);
+		return (DDI_INTR_UNCLAIMED);
 	}
 	if (index != 0xfffffffful) {
 		do {
 			if ((index & AAC_SENDERADDR_MASK_AIF) == 0) {
-				aac_handle_io(softs, index);
+				fast= index & AAC_SENDERADDR_MASK_FAST_RESPONSE;
+				index >>= 2;
+				ASSERT(index >= 0 && index < softs->total_slots);
+				aac_handle_io(softs, &softs->io_slot[index], fast);
 			} else if (index != 0xfffffffeul) {
 				struct aac_fib *fibp;	/* FIB in AIF queue */
-				uint16_t fib_size;
+				uint16_t fib_size, fib_size0;
 
 				/*
 				 * 0xfffffffe means that the controller wants
@@ -1384,13 +1528,25 @@
 				 */
 				index &= ~2;
 
-				fibp = (struct aac_fib *)(softs-> \
-				    pci_mem_base_vaddr + index);
-				fib_size = PCI_MEM_GET16(softs, index + \
+				mutex_enter(&softs->aifq_mutex);
+				/*
+				 * Copy AIF from adapter to the empty AIF slot
+				 */
+				fibp = &softs->aifq[softs->aifq_idx].d;
+				fib_size0 = PCI_MEM_GET16(softs, 0, index + \
 				    offsetof(struct aac_fib, Header.Size));
+				fib_size = (fib_size0 > AAC_FIB_SIZE) ?
+				    AAC_FIB_SIZE : fib_size0;
+				PCI_MEM_REP_GET8(softs, 0, index, fibp,
+				    fib_size);
 
-				aac_save_aif(softs, softs->pci_mem_handle,
-				    fibp, fib_size);
+				if (aac_check_acc_handle(softs-> \
+				    pci_mem_handle[0]) == DDI_SUCCESS)
+					(void) aac_handle_aif(softs, fibp);
+				else
+					aac_fm_service_impact(softs->devinfo_p,
+					    DDI_SERVICE_UNAFFECTED);
+				mutex_exit(&softs->aifq_mutex);
 
 				/*
 				 * AIF memory is owned by the adapter, so let it
@@ -1417,11 +1573,18 @@
 static uint_t
 aac_intr_new(caddr_t arg)
 {
-	struct aac_softstate *softs = (void *)arg;
+	struct aac_softstate *softs = (struct aac_softstate *)arg;
+	int status;
 	uint_t rval;
 
 	mutex_enter(&softs->io_lock);
-	if (aac_process_intr_new(softs))
+	if ((softs->flags & AAC_FLAGS_NEW_COMM_TYPE1) ||
+		(softs->flags & AAC_FLAGS_NEW_COMM_TYPE2) ||
+		(softs->flags & AAC_FLAGS_NEW_COMM_TYPE34))
+		status = aac_process_intr_new_type1(softs);
+	else
+		status = aac_process_intr_new(softs);
+	if (status)
 		rval = DDI_INTR_CLAIMED;
 	else
 		rval = DDI_INTR_UNCLAIMED;
@@ -1443,19 +1606,23 @@
 	uint16_t status;
 
 	status = AAC_STATUS_GET(softs);
-	if (aac_check_acc_handle(softs->pci_mem_handle) != DDI_SUCCESS) {
-		ddi_fm_service_impact(softs->devinfo_p, DDI_SERVICE_UNAFFECTED);
+	if (aac_check_acc_handle(softs->pci_mem_handle[0]) != DDI_SUCCESS) {
+		aac_fm_service_impact(softs->devinfo_p, DDI_SERVICE_UNAFFECTED);
 		return (DDI_INTR_UNCLAIMED);
 	}
 	if (status & AAC_DB_RESPONSE_READY) {
-		int slot_idx;
+		int slot_idx, fast;
 
 		/* ACK the intr */
 		AAC_STATUS_CLR(softs, AAC_DB_RESPONSE_READY);
 		(void) AAC_STATUS_GET(softs);
 		while (aac_fib_dequeue(softs, AAC_HOST_NORM_RESP_Q,
-		    &slot_idx) == AACOK)
-			aac_handle_io(softs, slot_idx);
+		    &slot_idx) == AACOK) {
+			fast = slot_idx & AAC_SENDERADDR_MASK_FAST_RESPONSE;
+			slot_idx >>= 2;
+			ASSERT(slot_idx >= 0 && slot_idx < softs->total_slots);
+			aac_handle_io(softs, &softs->io_slot[slot_idx], fast);
+        }
 
 		/*
 		 * Process waiting cmds before start new ones to
@@ -1471,8 +1638,9 @@
 		if (aac_fib_dequeue(softs, AAC_HOST_NORM_CMD_Q, &aif_idx) ==
 		    AACOK) {
 			ddi_acc_handle_t acc = softs->comm_space_acc_handle;
-			struct aac_fib *fibp;	/* FIB in communication space */
-			uint16_t fib_size;
+			struct aac_fib *fibp;	/* FIB in AIF queue */
+			struct aac_fib *fibp0;	/* FIB in communication space */
+			uint16_t fib_size, fib_size0;
 			uint32_t fib_xfer_state;
 			uint32_t addr, size;
 
@@ -1484,21 +1652,29 @@
 	    adapter_fibs[(aif_idx)]), AAC_FIB_SIZE, \
 	    (type)); }
 
+			mutex_enter(&softs->aifq_mutex);
 			/* Copy AIF from adapter to the empty AIF slot */
+			fibp = &softs->aifq[softs->aifq_idx].d;
 			AAC_SYNC_AIF(softs, aif_idx, DDI_DMA_SYNC_FORCPU);
-			fibp = &softs->comm_space->adapter_fibs[aif_idx];
-			fib_size = ddi_get16(acc, &fibp->Header.Size);
+			fibp0 = &softs->comm_space->adapter_fibs[aif_idx];
+			fib_size0 = ddi_get16(acc, &fibp0->Header.Size);
+			fib_size = (fib_size0 > AAC_FIB_SIZE) ?
+			    AAC_FIB_SIZE : fib_size0;
+			ddi_rep_get8(acc, (uint8_t *)fibp, (uint8_t *)fibp0,
+			    fib_size, DDI_DEV_AUTOINCR);
 
-			aac_save_aif(softs, acc, fibp, fib_size);
+			(void) aac_handle_aif(softs, fibp);
+			mutex_exit(&softs->aifq_mutex);
 
 			/* Complete AIF back to adapter with good status */
 			fib_xfer_state = LE_32(fibp->Header.XferState);
 			if (fib_xfer_state & AAC_FIBSTATE_FROMADAP) {
-				ddi_put32(acc, &fibp->Header.XferState,
+				ddi_put32(acc, &fibp0->Header.XferState,
 				    fib_xfer_state | AAC_FIBSTATE_DONEHOST);
-				ddi_put32(acc, (void *)&fibp->data[0], ST_OK);
-				if (fib_size > AAC_FIB_SIZE)
-					ddi_put16(acc, &fibp->Header.Size,
+				ddi_put32(acc, (uint32_t *)&fibp0->data[0],
+				    ST_OK);
+				if (fib_size0 > AAC_FIB_SIZE)
+					ddi_put16(acc, &fibp0->Header.Size,
 					    AAC_FIB_SIZE);
 				AAC_SYNC_AIF(softs, aif_idx,
 				    DDI_DMA_SYNC_FORDEV);
@@ -1513,7 +1689,7 @@
 			    Header.Size);
 			ddi_put32(acc,
 			    &softs->comm_space->adapter_fibs[aif_idx]. \
-			    Header.ReceiverFibAddress, addr);
+			    Header.a.ReceiverFibAddress, addr);
 			if (aac_fib_enqueue(softs, AAC_ADAP_NORM_RESP_Q,
 			    addr, size) == AACERR)
 				cmn_err(CE_NOTE, "!AIF ack failed");
@@ -1531,7 +1707,7 @@
 			cmn_err(CE_NOTE, "MSG From Adapter: %s",
 			    softs->comm_space->adapter_print_buf);
 		else
-			ddi_fm_service_impact(softs->devinfo_p,
+			aac_fm_service_impact(softs->devinfo_p,
 			    DDI_SERVICE_UNAFFECTED);
 		AAC_NOTIFY(softs, AAC_DB_PRINTF_READY);
 		return (AAC_DB_PRINTF_READY);
@@ -1556,7 +1732,7 @@
 static uint_t
 aac_intr_old(caddr_t arg)
 {
-	struct aac_softstate *softs = (void *)arg;
+	struct aac_softstate *softs = (struct aac_softstate *)arg;
 	int rval;
 
 	mutex_enter(&softs->io_lock);
@@ -1571,205 +1747,6 @@
 }
 
 /*
- * Query FIXED or MSI interrupts
- */
-static int
-aac_query_intrs(struct aac_softstate *softs, int intr_type)
-{
-	dev_info_t *dip = softs->devinfo_p;
-	int avail, actual, count;
-	int i, flag, ret;
-
-	AACDB_PRINT(softs, CE_NOTE,
-	    "aac_query_intrs:interrupt type 0x%x", intr_type);
-
-	/* Get number of interrupts */
-	ret = ddi_intr_get_nintrs(dip, intr_type, &count);
-	if ((ret != DDI_SUCCESS) || (count == 0)) {
-		AACDB_PRINT(softs, CE_WARN,
-		    "ddi_intr_get_nintrs() failed, ret %d count %d",
-		    ret, count);
-		return (DDI_FAILURE);
-	}
-
-	/* Get number of available interrupts */
-	ret = ddi_intr_get_navail(dip, intr_type, &avail);
-	if ((ret != DDI_SUCCESS) || (avail == 0)) {
-		AACDB_PRINT(softs, CE_WARN,
-		    "ddi_intr_get_navail() failed, ret %d avail %d",
-		    ret, avail);
-		return (DDI_FAILURE);
-	}
-
-	AACDB_PRINT(softs, CE_NOTE,
-	    "ddi_intr_get_nvail returned %d, navail() returned %d",
-	    count, avail);
-
-	/* Allocate an array of interrupt handles */
-	softs->intr_size = count * sizeof (ddi_intr_handle_t);
-	softs->htable = kmem_alloc(softs->intr_size, KM_SLEEP);
-
-	if (intr_type == DDI_INTR_TYPE_MSI) {
-		count = 1; /* only one vector needed by now */
-		flag = DDI_INTR_ALLOC_STRICT;
-	} else { /* must be DDI_INTR_TYPE_FIXED */
-		flag = DDI_INTR_ALLOC_NORMAL;
-	}
-
-	/* Call ddi_intr_alloc() */
-	ret = ddi_intr_alloc(dip, softs->htable, intr_type, 0,
-	    count, &actual, flag);
-
-	if ((ret != DDI_SUCCESS) || (actual == 0)) {
-		AACDB_PRINT(softs, CE_WARN,
-		    "ddi_intr_alloc() failed, ret = %d", ret);
-		actual = 0;
-		goto error;
-	}
-
-	if (actual < count) {
-		AACDB_PRINT(softs, CE_NOTE,
-		    "Requested: %d, Received: %d", count, actual);
-		goto error;
-	}
-
-	softs->intr_cnt = actual;
-
-	/* Get priority for first msi, assume remaining are all the same */
-	if ((ret = ddi_intr_get_pri(softs->htable[0],
-	    &softs->intr_pri)) != DDI_SUCCESS) {
-		AACDB_PRINT(softs, CE_WARN,
-		    "ddi_intr_get_pri() failed, ret = %d", ret);
-		goto error;
-	}
-
-	/* Test for high level mutex */
-	if (softs->intr_pri >= ddi_intr_get_hilevel_pri()) {
-		AACDB_PRINT(softs, CE_WARN,
-		    "aac_query_intrs: Hi level interrupt not supported");
-		goto error;
-	}
-
-	return (DDI_SUCCESS);
-
-error:
-	/* Free already allocated intr */
-	for (i = 0; i < actual; i++)
-		(void) ddi_intr_free(softs->htable[i]);
-
-	kmem_free(softs->htable, softs->intr_size);
-	return (DDI_FAILURE);
-}
-
-
-/*
- * Register FIXED or MSI interrupts, and enable them
- */
-static int
-aac_add_intrs(struct aac_softstate *softs)
-{
-	int i, ret;
-	int actual;
-	ddi_intr_handler_t *aac_intr;
-
-	actual = softs->intr_cnt;
-	aac_intr = (ddi_intr_handler_t *)((softs->flags & AAC_FLAGS_NEW_COMM) ?
-	    aac_intr_new : aac_intr_old);
-
-	/* Call ddi_intr_add_handler() */
-	for (i = 0; i < actual; i++) {
-		if ((ret = ddi_intr_add_handler(softs->htable[i],
-		    aac_intr, (caddr_t)softs, NULL)) != DDI_SUCCESS) {
-			cmn_err(CE_WARN,
-			    "ddi_intr_add_handler() failed ret = %d", ret);
-
-			/* Free already allocated intr */
-			for (i = 0; i < actual; i++)
-				(void) ddi_intr_free(softs->htable[i]);
-
-			kmem_free(softs->htable, softs->intr_size);
-			return (DDI_FAILURE);
-		}
-	}
-
-	if ((ret = ddi_intr_get_cap(softs->htable[0], &softs->intr_cap))
-	    != DDI_SUCCESS) {
-		cmn_err(CE_WARN, "ddi_intr_get_cap() failed, ret = %d", ret);
-
-		/* Free already allocated intr */
-		for (i = 0; i < actual; i++)
-			(void) ddi_intr_free(softs->htable[i]);
-
-		kmem_free(softs->htable, softs->intr_size);
-		return (DDI_FAILURE);
-	}
-
-	return (DDI_SUCCESS);
-}
-
-/*
- * Unregister FIXED or MSI interrupts
- */
-static void
-aac_remove_intrs(struct aac_softstate *softs)
-{
-	int i;
-
-	/* Disable all interrupts */
-	(void) aac_disable_intrs(softs);
-	/* Call ddi_intr_remove_handler() */
-	for (i = 0; i < softs->intr_cnt; i++) {
-		(void) ddi_intr_remove_handler(softs->htable[i]);
-		(void) ddi_intr_free(softs->htable[i]);
-	}
-
-	kmem_free(softs->htable, softs->intr_size);
-}
-
-static int
-aac_enable_intrs(struct aac_softstate *softs)
-{
-	int rval = AACOK;
-
-	if (softs->intr_cap & DDI_INTR_FLAG_BLOCK) {
-		/* for MSI block enable */
-		if (ddi_intr_block_enable(softs->htable, softs->intr_cnt) !=
-		    DDI_SUCCESS)
-			rval = AACERR;
-	} else {
-		int i;
-
-		/* Call ddi_intr_enable() for legacy/MSI non block enable */
-		for (i = 0; i < softs->intr_cnt; i++) {
-			if (ddi_intr_enable(softs->htable[i]) != DDI_SUCCESS)
-				rval = AACERR;
-		}
-	}
-	return (rval);
-}
-
-static int
-aac_disable_intrs(struct aac_softstate *softs)
-{
-	int rval = AACOK;
-
-	if (softs->intr_cap & DDI_INTR_FLAG_BLOCK) {
-		/* Call ddi_intr_block_disable() */
-		if (ddi_intr_block_disable(softs->htable, softs->intr_cnt) !=
-		    DDI_SUCCESS)
-			rval = AACERR;
-	} else {
-		int i;
-
-		for (i = 0; i < softs->intr_cnt; i++) {
-			if (ddi_intr_disable(softs->htable[i]) != DDI_SUCCESS)
-				rval = AACERR;
-		}
-	}
-	return (rval);
-}
-
-/*
  * Set pkt_reason and OR in pkt_statistics flag
  */
 static void
@@ -1795,7 +1772,7 @@
 	acp->flags |= AAC_CMD_CMPLT;
 
 	acp->pkt->pkt_state |= STATE_GOT_BUS | STATE_GOT_TARGET | \
-	    STATE_SENT_CMD | STATE_GOT_STATUS;
+	    STATE_SENT_CMD;
 	if (acp->pkt->pkt_state & STATE_XFERRED_DATA)
 		acp->pkt->pkt_resid = 0;
 
@@ -1826,8 +1803,6 @@
 	ASSERT(!(acp->flags & AAC_CMD_SYNC));
 	ASSERT(!(acp->flags & AAC_CMD_NO_CB));
 
-	acp->pkt->pkt_state |= STATE_GOT_STATUS;
-
 	/*
 	 * block_read/write has a similar response header, use blockread
 	 * response for both.
@@ -1837,6 +1812,8 @@
 	if (status == ST_OK) {
 		acp->pkt->pkt_resid = 0;
 		acp->pkt->pkt_state |= STATE_XFERRED_DATA;
+	} else if (status == ST_NOT_READY) {
+		aac_set_pkt_reason(softs, acp, CMD_TIMEOUT, STAT_TIMEOUT);
 	} else {
 		aac_set_arq_data_hwerr(acp);
 	}
@@ -1852,170 +1829,88 @@
 	struct aac_fib *fibp = acp->slotp->fibp;
 	struct scsi_pkt *pkt = acp->pkt;
 	struct aac_srb_reply *resp;
-	uint32_t resp_status;
+	uint32_t resp_status, scsi_status;
+	uint32_t srb_status, data_xfer_length;
+	uint32_t sense_data_size;
 
 	ASSERT(!(acp->flags & AAC_CMD_SYNC));
 	ASSERT(!(acp->flags & AAC_CMD_NO_CB));
 
 	resp = (struct aac_srb_reply *)&fibp->data[0];
-	resp_status = ddi_get32(acc, &resp->status);
+	if (acp->flags & AAC_CMD_FASTRESP) {
+		resp_status = ST_OK;
+		sense_data_size = 0;
+		srb_status = SRB_STATUS_SUCCESS;
+		data_xfer_length = 0;
+		scsi_status = 0;
+	} else {
+		resp_status = ddi_get32(acc, &resp->status);
+		sense_data_size = ddi_get32(acc, &resp->sense_data_size);
+		srb_status = ddi_get32(acc, &resp->srb_status);
+		data_xfer_length = ddi_get32(acc, &resp->data_xfer_length);
+		scsi_status = ddi_get32(acc, &resp->scsi_status);
+	}
 
 	/* First check FIB status */
 	if (resp_status == ST_OK) {
-		uint32_t scsi_status;
-		uint32_t srb_status;
-		uint32_t data_xfer_length;
+		if (data_xfer_length) {
+			/* When the cmd failed, data_xfer_length is 0 */
+			pkt->pkt_state |= STATE_XFERRED_DATA;
+			pkt->pkt_resid = acp->bcount - data_xfer_length;
+		}
 
-		scsi_status = ddi_get32(acc, &resp->scsi_status);
-		srb_status = ddi_get32(acc, &resp->srb_status);
-		data_xfer_length = ddi_get32(acc, &resp->data_xfer_length);
-
-		*pkt->pkt_scbp = (uint8_t)scsi_status;
-		pkt->pkt_state |= STATE_GOT_STATUS;
-		if (scsi_status == STATUS_GOOD) {
-			uchar_t cmd = ((union scsi_cdb *)(void *)
-			    (pkt->pkt_cdbp))->scc_cmd;
-
-			/* Next check SRB status */
-			switch (srb_status & 0x3f) {
-			case SRB_STATUS_DATA_OVERRUN:
-				AACDB_PRINT(softs, CE_NOTE, "DATA_OVERRUN: " \
-				    "scmd=%d, xfer=%d, buflen=%d",
-				    (uint32_t)cmd, data_xfer_length,
-				    acp->bcount);
-
-				switch (cmd) {
-				case SCMD_READ:
-				case SCMD_WRITE:
-				case SCMD_READ_G1:
-				case SCMD_WRITE_G1:
-				case SCMD_READ_G4:
-				case SCMD_WRITE_G4:
-				case SCMD_READ_G5:
-				case SCMD_WRITE_G5:
-					aac_set_pkt_reason(softs, acp,
-					    CMD_DATA_OVR, 0);
-					break;
-				}
-				/*FALLTHRU*/
-			case SRB_STATUS_ERROR_RECOVERY:
-			case SRB_STATUS_PENDING:
-			case SRB_STATUS_SUCCESS:
-				/*
-				 * pkt_resid should only be calculated if the
-				 * status is ERROR_RECOVERY/PENDING/SUCCESS/
-				 * OVERRUN/UNDERRUN
-				 */
-				if (data_xfer_length) {
-					pkt->pkt_state |= STATE_XFERRED_DATA;
-					pkt->pkt_resid = acp->bcount - \
-					    data_xfer_length;
-					ASSERT(pkt->pkt_resid >= 0);
-				}
+		/* Next check SRB status */
+		switch (srb_status & 0x3f) {
+		case SRB_STATUS_ERROR_RECOVERY:
+		case SRB_STATUS_PENDING:
+		case SRB_STATUS_SUCCESS:
+			break;
+		case SRB_STATUS_ABORTED:
+			aac_set_pkt_reason(softs, acp, CMD_ABORTED,
+			    STAT_ABORTED);
+			break;
+		case SRB_STATUS_ABORT_FAILED:
+			aac_set_pkt_reason(softs, acp, CMD_ABORT_FAIL, 0);
+			break;
+		case SRB_STATUS_DATA_OVERRUN:
+			switch (((union scsi_cdb *)(pkt->pkt_cdbp))->scc_cmd) {
+			case SCMD_READ:
+			case SCMD_WRITE:
+			case SCMD_READ_G1:
+			case SCMD_WRITE_G1:
+			case SCMD_READ_G4:
+			case SCMD_WRITE_G4:
+				aac_set_pkt_reason(softs, acp, CMD_DATA_OVR, 0);
 				break;
-			case SRB_STATUS_ABORTED:
-				AACDB_PRINT(softs, CE_NOTE,
-				    "SRB_STATUS_ABORTED, xfer=%d, resid=%d",
-				    data_xfer_length, pkt->pkt_resid);
-				aac_set_pkt_reason(softs, acp, CMD_ABORTED,
-				    STAT_ABORTED);
-				break;
-			case SRB_STATUS_ABORT_FAILED:
-				AACDB_PRINT(softs, CE_NOTE,
-				    "SRB_STATUS_ABORT_FAILED, xfer=%d, " \
-				    "resid=%d", data_xfer_length,
-				    pkt->pkt_resid);
-				aac_set_pkt_reason(softs, acp, CMD_ABORT_FAIL,
-				    0);
-				break;
-			case SRB_STATUS_PARITY_ERROR:
-				AACDB_PRINT(softs, CE_NOTE,
-				    "SRB_STATUS_PARITY_ERROR, xfer=%d, " \
-				    "resid=%d", data_xfer_length,
-				    pkt->pkt_resid);
-				aac_set_pkt_reason(softs, acp, CMD_PER_FAIL, 0);
-				break;
-			case SRB_STATUS_NO_DEVICE:
-			case SRB_STATUS_INVALID_PATH_ID:
-			case SRB_STATUS_INVALID_TARGET_ID:
-			case SRB_STATUS_INVALID_LUN:
-			case SRB_STATUS_SELECTION_TIMEOUT:
-#ifdef DEBUG
-				if (AAC_DEV_IS_VALID(acp->dvp)) {
-					AACDB_PRINT(softs, CE_NOTE,
-					    "SRB_STATUS_NO_DEVICE(%d), " \
-					    "xfer=%d, resid=%d ",
-					    srb_status & 0x3f,
-					    data_xfer_length, pkt->pkt_resid);
-				}
-#endif
-				aac_set_pkt_reason(softs, acp, CMD_DEV_GONE, 0);
-				break;
-			case SRB_STATUS_COMMAND_TIMEOUT:
-			case SRB_STATUS_TIMEOUT:
-				AACDB_PRINT(softs, CE_NOTE,
-				    "SRB_STATUS_COMMAND_TIMEOUT, xfer=%d, " \
-				    "resid=%d", data_xfer_length,
-				    pkt->pkt_resid);
-				aac_set_pkt_reason(softs, acp, CMD_TIMEOUT,
-				    STAT_TIMEOUT);
-				break;
-			case SRB_STATUS_BUS_RESET:
-				AACDB_PRINT(softs, CE_NOTE,
-				    "SRB_STATUS_BUS_RESET, xfer=%d, " \
-				    "resid=%d", data_xfer_length,
-				    pkt->pkt_resid);
-				aac_set_pkt_reason(softs, acp, CMD_RESET,
-				    STAT_BUS_RESET);
-				break;
-			default:
-				AACDB_PRINT(softs, CE_NOTE, "srb_status=%d, " \
-				    "xfer=%d, resid=%d", srb_status & 0x3f,
-				    data_xfer_length, pkt->pkt_resid);
-				aac_set_pkt_reason(softs, acp, CMD_TRAN_ERR, 0);
-				break;
 			}
-		} else if (scsi_status == STATUS_CHECK) {
-			/* CHECK CONDITION */
-			struct scsi_arq_status *arqstat =
-			    (void *)(pkt->pkt_scbp);
-			uint32_t sense_data_size;
-
-			pkt->pkt_state |= STATE_ARQ_DONE;
-
-			*(uint8_t *)&arqstat->sts_rqpkt_status = STATUS_GOOD;
-			arqstat->sts_rqpkt_reason = CMD_CMPLT;
-			arqstat->sts_rqpkt_resid = 0;
-			arqstat->sts_rqpkt_state =
-			    STATE_GOT_BUS |
-			    STATE_GOT_TARGET |
-			    STATE_SENT_CMD |
-			    STATE_XFERRED_DATA;
-			arqstat->sts_rqpkt_statistics = 0;
-
-			sense_data_size = ddi_get32(acc,
-			    &resp->sense_data_size);
-			ASSERT(sense_data_size <= AAC_SENSE_BUFFERSIZE);
-			AACDB_PRINT(softs, CE_NOTE,
-			    "CHECK CONDITION: sense len=%d, xfer len=%d",
-			    sense_data_size, data_xfer_length);
-
-			if (sense_data_size > SENSE_LENGTH)
-				sense_data_size = SENSE_LENGTH;
-			ddi_rep_get8(acc, (uint8_t *)&arqstat->sts_sensedata,
-			    (uint8_t *)resp->sense_data, sense_data_size,
-			    DDI_DEV_AUTOINCR);
-		} else {
-			AACDB_PRINT(softs, CE_WARN, "invaild scsi status: " \
-			    "scsi_status=%d, srb_status=%d",
-			    scsi_status, srb_status);
+			break;
+		case SRB_STATUS_COMMAND_TIMEOUT:
+		case SRB_STATUS_TIMEOUT:
+			aac_set_pkt_reason(softs, acp, CMD_TIMEOUT,
+			    STAT_TIMEOUT);
+			break;
+		case SRB_STATUS_BUS_RESET:
+			aac_set_pkt_reason(softs, acp, CMD_RESET,
+			    STAT_BUS_RESET);
+			break;
+		default:
 			aac_set_pkt_reason(softs, acp, CMD_TRAN_ERR, 0);
+			break;
 		}
+	} else if (resp_status == ST_NOT_READY) {
+		aac_set_pkt_reason(softs, acp, CMD_TIMEOUT, STAT_TIMEOUT);
 	} else {
 		AACDB_PRINT(softs, CE_NOTE, "SRB failed: fib status %d",
 		    resp_status);
-		aac_set_pkt_reason(softs, acp, CMD_TRAN_ERR, 0);
 	}
+
+	/* Finally SCSI status */
+	if (scsi_status == 2) {
+		AACDB_PRINT(softs, CE_NOTE, "CHECK CONDITION: len=%d",
+		    sense_data_size);
+		ASSERT(sense_data_size <= AAC_SENSE_BUFFERSIZE);
+		aac_copy_arq_data(pkt, resp->sense_data, sense_data_size, acc);
+	}
 }
 
 /*
@@ -2045,15 +1940,6 @@
 }
 
 /*
- * Handle completed sync fib command
- */
-/*ARGSUSED*/
-void
-aac_sync_complete(struct aac_softstate *softs, struct aac_cmd *acp)
-{
-}
-
-/*
  * Handle completed Flush command
  */
 /*ARGSUSED*/
@@ -2067,8 +1953,6 @@
 
 	ASSERT(!(acp->flags & AAC_CMD_SYNC));
 
-	acp->pkt->pkt_state |= STATE_GOT_STATUS;
-
 	resp = (struct aac_synchronize_reply *)&slotp->fibp->data[0];
 	status = ddi_get32(acc, &resp->Status);
 	if (status != CT_OK)
@@ -2075,24 +1959,44 @@
 		aac_set_arq_data_hwerr(acp);
 }
 
+/*
+ * Handle completed AIF request command
+ */
 /*ARGSUSED*/
 static void
-aac_startstop_complete(struct aac_softstate *softs, struct aac_cmd *acp)
+aac_aifreq_complete(struct aac_softstate *softs, struct aac_cmd *acp)
 {
 	struct aac_slot *slotp = acp->slotp;
 	ddi_acc_handle_t acc = slotp->fib_acc_handle;
-	struct aac_Container_resp *resp;
 	uint32_t status;
+	struct aac_fib *fibp;	/* FIB in AIF queue */
+	uint16_t fib_size, fib_size0;
 
 	ASSERT(!(acp->flags & AAC_CMD_SYNC));
 
-	acp->pkt->pkt_state |= STATE_GOT_STATUS;
+	acp->flags |= AAC_CMD_AIF;
+	status = ddi_get32(acc, &slotp->fibp->Header.XferState);
+	if (status & AAC_FIBSTATE_NOMOREAIF) {
+		acp->flags |= AAC_CMD_AIF_NOMORE;
+	} else {
+		mutex_enter(&softs->aifq_mutex);
+		/*
+		 * Copy AIF from adapter to the empty AIF slot
+		 */
+		fibp = &softs->aifq[softs->aifq_idx].d;
+		fib_size0 = ddi_get16(acc, &slotp->fibp->Header.Size);
+		fib_size = (fib_size0 > AAC_FIB_SIZE) ?
+			AAC_FIB_SIZE : fib_size0;
+		ddi_rep_get8(acc, (uint8_t *)fibp, (uint8_t *)slotp->fibp,
+			fib_size, DDI_DEV_AUTOINCR);
 
-	resp = (struct aac_Container_resp *)&slotp->fibp->data[0];
-	status = ddi_get32(acc, &resp->Status);
-	if (status != 0) {
-		AACDB_PRINT(softs, CE_WARN, "Cannot start/stop a unit");
-		aac_set_arq_data_hwerr(acp);
+		if (aac_check_acc_handle(softs-> \
+			pci_mem_handle[0]) == DDI_SUCCESS)
+			(void) aac_handle_aif(softs, fibp);
+		else
+			aac_fm_service_impact(softs->devinfo_p,
+				DDI_SERVICE_UNAFFECTED);
+		mutex_exit(&softs->aifq_mutex);
 	}
 }
 
@@ -2152,6 +2056,14 @@
 		case 0x286:
 			softs->hwif = AAC_HWIF_RKT;
 			break;
+		case 0x28b:
+			softs->hwif = AAC_HWIF_SRC;
+			break;
+		case 0x28c:
+		case 0x28d:
+		case 0x28f:
+			softs->hwif = AAC_HWIF_SRCV;
+			break;
 		default:
 			AACDB_PRINT(softs, CE_WARN,
 			    "Unknown device \"pci9005,%x\"", softs->devid);
